unit integerlettres;
{*****************************************************************************} 
{    F.A.Q Delphi - www.developpez.com                                        } 
{                                                                             }
{ Comment transformer un nombre en lettres                                    }
{ Auteur : inconnu, cit par bloon                                            }
{                                                                             }
{ Delphi Version(s) Edition(s)                                                }
{*****************************************************************************}

interface

function NombreEnLettres(n : integer ; France : Boolean = True ) : string;

implementation

Uses SysUtils;

function NombreEnLettres(n : integer ; France : Boolean = True ) : string;
Const
  unite   : array[1..19] of string = ('un','deux','trois','quatre','cinq','six',
                                      'sept','huit','neuf','dix','onze','douze',
                                      'treize','quatorze','quinze','seize',
                                      'dix sept','dix huit','dix neuf');
  dizaineF: array[2.. 9] of string = ('vingt','trente','quarante','cinquante',
                                     'soixante','','quatre-vingt','');
  dizaineB: array[2.. 9] of string = ('vingt','trente','quarante','cinquante',
                                     'soixante','septante','octante','nonante');
  coefs   : array[0.. 3] of string = ('cent','mille','million','milliard');
Var
  temp    : String;
  c, d, u : Integer;
  coef    : Integer;
  i       : Integer;
  neg     : boolean;
Begin
  result := '';

  // Cas particulier de zro
  If n = 0 then
  begin
    result := ' zero';
    exit;
  end;

  // Mmorisation du signe
  neg := n < 0;
  If neg then n := -n;

  coef:=0;
  Repeat
    // Rcupration de l'unit du bloc de trois chiffres en cours
    u:=n mod 10; n:=n div 10;
    // Rcupration de la dizaine du bloc de trois chiffres en cours
    d:=n mod 10; n:=n div 10;

    // Traitement des dizaines
    temp := '';
    // Passage sur la dizaine infrieure pour 10  19
    // et pour 70-79 90-99 dans le cas de la France
    If (d=1) Or ((d in [7,9])And France) then
    begin
      Dec(d);
      Inc(u,10);
    end;
    if d > 1 then
    begin
      If France Then
      Begin
        temp := ' ' + DizaineF[d];
        // Ajout du cas particulier de 'et' entre la dizaine et 1
        if (d < 8) and ((u = 1) or (u = 11)) then
          temp := temp + ' et';
      End Else
      Begin
        temp := ' ' + DizaineB[d];
        // Ajout du cas particulier de 'et' entre la dizaine et 1
        if (u = 1) then
          temp := temp + ' et';
      End;
    end;
    // ajout du texte de l'unit
    if u > 0 then temp := temp + ' ' + unite[u];
    // ajout du 's'  Quatre-vingt si rien ne suit
    If (result = '') and (d = 8) and (u = 0) and France then result := 's';
    result := temp + result;

    // Rcupration de la centaine du bloc de trois chiffres en cours
    c := n mod 10; n := n div 10; {Rcupre centaine}
    If c > 0 then
    begin
      temp := '';
      if c > 1 then temp := ' ' + unite[c] + temp;
      temp := temp + ' ' + coefs[0];
      // Traitement du cas particulier du 's'  cent si rien ne suit
      If (result = '') and (c > 1) then result := 's';
      result := temp + result;
    end;

    // Traitement du prochain groupe de 3 chiffres
    if n > 0 then
    begin
      Inc(coef);
      I := n mod 1000;
      If (i > 1) and (coef > 1) then result := 's' + result;
      If i > 0 then result := ' ' + coefs[coef] + result;
      // Traitement du cas particulier 'mille' ( non pas 'un mille' )
      If (i = 1) and (coef = 1) then Dec(n);
    end;
  until n = 0;
  result := Trim(result);

  // Ajout du signe en cas de besoin
  if neg then result := 'moins ' + result;
End;

end.
